﻿Public Class Form1
    ' Set the drop target PictureBox's AllowDrop property at run time.
    ' It is unavailable in the Properties window and doesn't
    ' even show up in IntelliSense!
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        picDropTarget.AllowDrop = True
    End Sub

    ' Start the drag.
    Private Sub picDragSource_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picDragSource.MouseDown, picDragSource2.MouseDown
        ' Start the drag if it's the right mouse button.
        If (e.Button = MouseButtons.Right) Then
            Dim source As PictureBox = DirectCast(sender, PictureBox)
            picDragSource.DoDragDrop(source.Image, DragDropEffects.Copy)
        End If
    End Sub

    ' The current image during a drag.
    Private OldImage As Image = Nothing

    ' Allow a copy of an image.
    Private Sub picDropTarget_DragEnter(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles picDropTarget.DragEnter
        ' See if this is a copy and the data includes an image.
        If (e.Data.GetDataPresent(DataFormats.Bitmap) AndAlso _
           (e.AllowedEffect And DragDropEffects.Copy) <> 0) _
        Then
            ' Allow this.
            e.Effect = DragDropEffects.Copy

            ' Save the current image.
            OldImage = picDropTarget.Image

            ' Display the preview image.
            Dim bm As Bitmap = DirectCast(e.Data.GetData(DataFormats.Bitmap, True), Bitmap)
            Dim copy_bm As Bitmap = DirectCast(bm.Clone(), Bitmap)
            Using gr As Graphics = Graphics.FromImage(copy_bm)
                ' Cover with translucent white.
                Using br As New SolidBrush(Color.FromArgb(128, 255, 255, 255))
                    gr.FillRectangle(br, 0, 0, bm.Width, bm.Height)
                End Using
            End Using
            picDropTarget.Image = copy_bm
        Else
            ' Don't allow any other drop.
            e.Effect = DragDropEffects.None
        End If
    End Sub

    ' Accept the drop.
    Private Sub picDropTarget_DragDrop(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles picDropTarget.DragDrop
        Dim bm As Bitmap = DirectCast(e.Data.GetData(DataFormats.Bitmap, True), Bitmap)
        picDropTarget.ClientSize = bm.Size
        picDropTarget.Image = bm
    End Sub

    ' Remove the drag enter image.
    Private Sub picDropTarget_DragLeave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picDropTarget.DragLeave
        ' Restore the saved image.
        picDropTarget.Image = OldImage
    End Sub
End Class
